% !TEX root = termpaper.tex
% Commands for configurations
%
% @author: Thomas Lehmann

\RequirePackage{ifthen}

% Configuration values
\newcommand{\firstSupervisor}[1]{\newcommand{\IfirstSv}{#1}}
\newcommand{\secondSupervisor}[1]{\newcommand{\IsecondSv}{#1}}
\newcommand{\submissionDate}[1]{\newcommand{\ISubDate}{#1}}

% Which regulations (APSO-INGI/APSO-BMT)
\newcommand{\FakPO}[1]{\newcommand{\IfacultyRegulations}{#1}}
\newcommand{\PO}[1]{\newcommand{\IcurriculumRegulations}{#1}}

% Title and author
\newcommand{\termPaperTitle}[1]{\newcommand{\IthesisTitle}{#1}}
\newcommand{\termPaperTitleEN}[1]{\newcommand{\IthesisTitleEN}{#1}}
\newcommand{\termPaperAuthor}[1]{\newcommand{\IthesisAuthor}{#1}}

% constant text replacements
\newcommand{\IthesisFacultyFull}{Fakultät Technik und Informatik}
\newcommand{\ICDthesisFacultyFull}{FAKULTÄT TECHNIK UND INFORMATIK}
\newcommand{\IthesisFacultyFullEN}{}
\newcommand{\ICDthesisFacultyFullEN}{FACULTY OF ENGINEERING AND COMPUTER SCIENCE}

% English language support
\newcommand{\fullenglish}[1]
{
  \ifthenelse{\equal{#1}{yes}} 
  {
    \newcommand{\ILanguageEN}{}
  }
}

% constant commands
\newcommand{\ITocEntryStatement}{
  \ifdefined\ILanguageEN
    \addcontentsline{toc}{section}{Declaration of Autorship}
  \else
    \addcontentsline{toc}{section}{Selbstständigkeitserklärung}  
  \fi
}

%% selectable text replacements
\newcommand{\NDA}[1]
{
  \ifdefined\ILanguageEN
    \ifthenelse{\equal{#1}{yes}} {\newcommand{\IthesisNDAFull}{STRICTLY CONFIDENTIAL}} {\newcommand{\IthesisNDAFull}{}}
  \else
    \ifthenelse{\equal{#1}{yes}}{\newcommand{\IthesisNDAFull}{STRENG VERTRAULICH}}{\newcommand{\IthesisNDAFull}{}}
  \fi
}

%% coverpage
\newcommand{\Cover}[1]
{
  \ifthenelse{\equal{#1}{Std2018}} {\newcommand{\ICoverPage}{\input{style/coverpage}}}{}
  \ifthenelse{\equal{#1}{CD2017}} {
    \newcommand{\ICoverPage}{\input{style/coverpageCD2017}}
    \newcommand{\ICDLogo}{\includegraphics[scale=0.5]{style/HAW_Marke_schwarz}}
    \ifdefined\ILanguageEN
       \newcommand{\ICDBottomLogo}{
          % Bottom Logo
          \begin{textblock*}{\textwidth}(140mm,249mm)
            \begin{minipage}[b][0cm][t]{\textwidth}
              \fontfamily{fos}
              \fontsize{9pt}{9pt}
              \selectfont
              \begin{picture}(10, 2)(2, -10)
                \linethickness{0.9mm} 
                \line(3,0){30}
              \end{picture}
              \vspace{-5mm}
              \begin{flushleft}
                \textbf{HOCHSCHULE FÜR ANGEWANDTE\\WISSENSCHAFTEN HAMBURG}
              \end{flushleft}
              \fontsize{9pt}{8pt}
              \selectfont
              \vspace{-6mm}
              \begin{flushleft}
                \textbf{Hamburg University of Applied Sciences}
              \end{flushleft}
            \end{minipage}
          \end{textblock*}
          }
    \else
       \newcommand{\ICDBottomLogo}{
          % Bottom Logo
          \begin{textblock*}{\textwidth}(140mm,249mm)
            \begin{minipage}[b][0cm][t]{\textwidth}
            \fontfamily{opensans}
              \fontsize{9pt}{9pt}
              \selectfont
              \begin{picture}(10, 2)(2, -10)
                \linethickness{0.9mm} 
                \line(3,0){30}
              \end{picture}
              \vspace{-5mm}
              \begin{flushleft}
                \textbf{HOCHSCHULE FÜR ANGEWANDTE\\WISSENSCHAFTEN HAMBURG}
              \end{flushleft}
              \fontsize{9pt}{8pt}
              \selectfont
              \vspace{-6mm}
              \begin{flushleft}
                \textbf{Hamburg University of Applied Sciences}
              \end{flushleft}
            \end{minipage}
          \end{textblock*}
          }
    \fi
    } 
    {}
  \ifthenelse{\equal{#1}{CD2017NoLogo}} {
    \newcommand{\ICoverPage}{\input{style/coverpageCD2017}}
    \newcommand{\ICDLogo}{}
    \newcommand{\ICDBottomLogo}{}} {}
}

\newcommand{\ListOfFigures}[1]
{
  \ifthenelse{\equal{#1}{yes}}
  {\newcommand{\IListOfFigures}{
    \listoffigures
  }}
  {\newcommand{\IListOfFigures}{}}
}

\newcommand{\ListOfTables}[1]
{
  \ifthenelse{\equal{#1}{yes}}
  {\newcommand{\IListOfTables}{
    \listoftables
  }}
  {\newcommand{\IListOfTables}{}}
}

% typically not used in term papers
\newcommand{\ListOfAccronyms}[1]
{
  \ifthenelse{\equal{#1}{yes}}
  {
    \ifdefined\ILanguageEN
      \newcommand{\IListOfAccronyms}{
        \printglossary[type=\acronymtype, title=Abbreviations]
      }
    \else
      \newcommand{\IListOfAccronyms}{
        \printglossary[type=\acronymtype, title=Abkürzungen]
      }
    \fi
  }
  {
    \newcommand{\IListOfAccronyms}{}
  }
}

% typically not used in term papers
\newcommand{\ListOfSymbols}[1]
{
  \ifthenelse{\equal{#1}{yes}}
  {
    \ifdefined\ILanguageEN
      \newcommand{\IListOfSymbols}{
        \printglossary[type=symbols, title=Symbols]
      }
    \else
      \newcommand{\IListOfSymbols}{
        \printglossary[type=symbols, title=Symbolverzeichnis]
      }
    \fi
  }
  {
    \newcommand{\IListOfSymbols}{}
  }
}

% typically not used in term papers
\newcommand{\Glossary}[1]
{
  \ifthenelse{\equal{#1}{yes}}
  {
    \ifdefined\ILanguageEN
      \newcommand{\IGlossary}{
        \printglossary[title=Glossary]
      }
    \else
      \newcommand{\IGlossary}{
        \printglossary[title=Glossar]
      }
    \fi
  }
  {\newcommand{\IGlossary}{}}
}

\newcommand{\department}[1]
{
  \ifdefined\ILanguageEN
    \ifthenelse{\equal{#1}{I}}{\newcommand{\IthesisDepartmentFull}{Department Computer Science}\newcommand{\IthesisDepartmentFullEN}{Department Computer Science}\newcommand{\Istatement}{\input{style/statement}}}{}
    \ifthenelse{\equal{#1}{IE}}{\newcommand{\IthesisDepartmentFull}{Department Information and Electrical Engineering}\newcommand{\IthesisDepartmentFullEN}{Department Information and Electrical Engineering}\newcommand{\Istatement}{\input{style/statement}}}{}
    \ifthenelse{\equal{#1}{FF}}{\newcommand{\IthesisDepartmentFull}{Department of Automotive and \\
Aeronautical Engineering}\newcommand{\IthesisDepartmentFullEN}{Department of Automotive and \\
Aeronautical Engineering}\newcommand{\Istatement}{\input{style/statement_fuf}}}{}
  \else
    \ifthenelse{\equal{#1}{I}}{\newcommand{\IthesisDepartmentFull}{Department Informatik}\newcommand{\IthesisDepartmentFullEN}{Department Computer Science}\newcommand{\Istatement}{\input{style/statement}}}{}
    \ifthenelse{\equal{#1}{IE}}{\newcommand{\IthesisDepartmentFull}{Department Informations- und Elektrotechnik}\newcommand{\IthesisDepartmentFullEN}{}\newcommand{\Istatement}{\input{style/statement}}}{}
    \ifthenelse{\equal{#1}{FF}}{\newcommand{\IthesisDepartmentFull}{Department Fahrzeugtechnik und Flugzeugbau}\newcommand{\IthesisDepartmentFullEN}{Department of Automotive and Aeronautical Engineering}\newcommand{\Istatement}{\input{style/statement_fuf}}}{}
  \fi
}

\newcommand{\studycourse}[1]
{
  \ifthenelse{\equal{#1}{ITS}}{\thesisKind{Bachelor}\department{I}\newcommand{\IstudyCourseName}{Bachelor of Science Informatik Technischer Systeme}}{}
  \ifthenelse{\equal{#1}{TI}}{\thesisKind{Bachelor}\department{I}\newcommand{\IstudyCourseName}{Bachelor of Science Technische Informatik}}{}
  \ifthenelse{\equal{#1}{AI}}{\thesisKind{Bachelor}\department{I}\newcommand{\IstudyCourseName}{Bachelor of Science Angewandte Informatik}}{}
  \ifthenelse{\equal{#1}{WI}}{\thesisKind{Bachelor}\department{I}\newcommand{\IstudyCourseName}{Bachelor of Science Wirtschaftsinformatik}}{}
  \ifthenelse{\equal{#1}{EI}}{\thesisKind{Bachelor}\department{IE}\newcommand{\IstudyCourseName}{Bachelor of Science Elektro- und Informationstechnik}}{}
  \ifthenelse{\equal{#1}{REE}}{\thesisKind{Bachelor}\department{IE}\newcommand{\IstudyCourseName}{Bachelor of Science Regenerative Energiesysteme und Energiemanagement}}{}
  \ifthenelse{\equal{#1}{BMT}}{\thesisKind{Bachelor}\department{FF}\newcommand{\IstudyCourseName}{Bachelor of Science Mechatronik}}{}
  \ifthenelse{\equal{#1}{MI}}{\thesisKind{Master}\department{I}\newcommand{\IstudyCourseName}{Master of Science Informatik}}{}
  \ifthenelse{\equal{#1}{MIK}}{\thesisKind{Master}\department{IE}\newcommand{\IstudyCourseName}{Master of Science Informations- und Kommunikationstechnik}}{}
  \ifthenelse{\equal{#1}{MA}}{\thesisKind{Master}\department{IE}\newcommand{\IstudyCourseName}{Master of Science Automatisierung}}{}
  \ifthenelse{\equal{#1}{MES}}{\thesisKind{Master}\department{IE}\newcommand{\IstudyCourseName}{Master of Science Mikroelektronische Systeme}}{}
}

\newcommand{\keywordsDE}[1]{\newcommand{\IkeyWordsDE}{#1}}
\newcommand{\keywordsEN}[1]{\newcommand{\IkeyWordsEN}{#1}}

\newcommand{\thesisKind}[1]
{
  % not required for term papers
}

\newcommand{\ITextBlockSupervisionOnCover}{
\begin{textblock*}{\textwidth}(20mm,235mm)
  \begin{minipage}[b][0cm][t]{\textwidth}
  \fontsize{11pt}{10pt}
  \selectfont
    \begin{flushleft}
    \ifdefined\ILanguageEN
      Supervision: \ITextBlockSupervision \\
      Submitted: \ISubDate \\
    \else
      Betreuung durch: \ITextBlockSupervision \\
      Eingereicht am: \ISubDate \\
    \fi
    \end{flushleft}
  \end{minipage}
\end{textblock*}
}

\newcommand{\termpaperKind}[1]
{
  \ifdefined\ILanguageEN
    \ifthenelse{\equal{#1}{E}}{\newcommand{\IthesisKind}{Exposé}\newcommand{\IthesisKindDE}{Exposé}\newcommand{\IthesisExaminationDE}{Bachelor´s degree course}\newcommand{\ICDthesisKind}{PROPOSAL}\newcommand{\ISuppressStatement}{}\newcommand{\ISuppressAbstract}{}}{}
    \ifthenelse{\equal{#1}{S}}{\newcommand{\IthesisKind}{Seminar Paper}\newcommand{\IthesisKindDE}{Seminararbeit}\newcommand{\IthesisExaminationDE}{Bachelor’s degree course}\newcommand{\ICDthesisKind}{SEMINAR PAPER}}{}
    \ifthenelse{\equal{#1}{H}}{\newcommand{\IthesisKind}{Hausarbeit}\newcommand{\IthesisKindDE}{Hausarbeit}\newcommand{\IthesisExaminationDE}{Bachelor’s degree course}\newcommand{\ICDthesisKind}{Written Paper}}{}
    \ifthenelse{\equal{#1}{Project}}{\newcommand{\IthesisKind}{Project Report}\newcommand{\IthesisKindDE}{Projektbereicht}\newcommand{\IthesisExaminationDE}{Bachelor’s degree course}\newcommand{\ICDthesisKind}{PROJECT REPORT}}{}
    \ifthenelse{\equal{#1}{MH}}{\newcommand{\IthesisKind}{Hausarbeit}\newcommand{\IthesisKindDE}{Hausarbeit}\newcommand{\IthesisExaminationDE}{Master’s degree course}\newcommand{\ICDthesisKind}{WRITTEN PAPER}}{}
    \ifthenelse{\equal{#1}{Research1}}{\newcommand{\IthesisKind}{Forschungswerkstatt 1}\newcommand{\IthesisKindDE}{Forschungswerkstatt 1}\newcommand{\IthesisExaminationDE}{Master’s degree course}\newcommand{\ICDthesisKind}{REASEARCH WORKSHOP 1}}{}
    \ifthenelse{\equal{#1}{Research2}}{\newcommand{\IthesisKind}{Forschungswerkstatt 2}\newcommand{\IthesisKindDE}{Forschungswerkstatt 2}\newcommand{\IthesisExaminationDE}{Master’s degree course}\newcommand{\ICDthesisKind}{REASEARCH WORKSHOP 2}}{}
  \else
    \ifthenelse{\equal{#1}{E}}{\newcommand{\IthesisKind}{Exposé}\newcommand{\IthesisKindDE}{Exposé}\newcommand{\IthesisExaminationDE}{Bachelorstudiengang}\newcommand{\ICDthesisKind}{EXPOSÉ}\newcommand{\ISuppressStatement}{}\newcommand{\ISuppressAbstract}{}}{}
    \ifthenelse{\equal{#1}{S}}{\newcommand{\IthesisKind}{Seminararbeit}\newcommand{\IthesisKindDE}{Seminararbeit}\newcommand{\IthesisExaminationDE}{Bachelorstudiengang}\newcommand{\ICDthesisKind}{SEMINARARBEIT}}{}
    \ifthenelse{\equal{#1}{H}}{\newcommand{\IthesisKind}{Hausarbeit}\newcommand{\IthesisKindDE}{Hausarbeit}\newcommand{\IthesisExaminationDE}{Bachelorstudiengang}\newcommand{\ICDthesisKind}{HAUSARBEIT}}{}
    \ifthenelse{\equal{#1}{Project}}{\newcommand{\IthesisKind}{BMT6-Sensorik-Projekt Dokumentation}\newcommand{\IthesisKindDE}{BMT6-Sensorik-Projekt Dokumentation}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{BMT6-SENSORIK-PROJEKT DOKUMENTATION}}{}
    \ifthenelse{\equal{#1}{GSem}}{\newcommand{\IthesisKind}{Grundseminararbeit}\newcommand{\IthesisKindDE}{Grundseminararbeit}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{GRUNDSEMINAR}}{}
    \ifthenelse{\equal{#1}{HSem}}{\newcommand{\IthesisKind}{Hauptseminararbeit}\newcommand{\IthesisKindDE}{Hauptseminararbeit}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{HAUPTSEMINAR}}{}
    \ifthenelse{\equal{#1}{MH}}{\newcommand{\IthesisKind}{Hausarbeit}\newcommand{\IthesisKindDE}{Hausarbeit}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{HAUSARBEIT}}{}
    \ifthenelse{\equal{#1}{Research1}}{\newcommand{\IthesisKind}{Forschungswerkstatt 1}\newcommand{\IthesisKindDE}{Forschungswerkstatt 1}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{FORSCHUNGSWERKSTATT 1}}{}
    \ifthenelse{\equal{#1}{Research2}}{\newcommand{\IthesisKind}{Forschungswerkstatt 2}\newcommand{\IthesisKindDE}{Forschungswerkstatt 2}\newcommand{\IthesisExaminationDE}{Masterstudiengang}\newcommand{\ICDthesisKind}{FORSCHUNGSWERKSTATT 2}}{}
    \ifthenelse{\equal{#1}{Pro}}{\newcommand{\IthesisKind}{Proseminararbeit}\newcommand{\IthesisKindDE}{Proseminararbeit}\newcommand{\IthesisExaminationDE}{Bachelorstudiengang}\newcommand{\ICDthesisKind}{PROSEMINARARBEIT}}{}
  \fi
}

\newcommand{\ITextBlockSupervision}{\ITextSupervision{\IfirstSv}{\IsecondSv}}
\newcommand{\ITextSupervision}[2]
{
  \ifthenelse{\equal{#2}{}}{#1}{#1 / #2}
}

\newcommand{\ITextBlockKeywords}{\ITextKeywords{\IkeyWordsDE}}
\newcommand{\ITextKeywords}[1]
{
  \ifthenelse{\equal{#1}{}} {} {\textbf{Keywords: #1}}
}

% automatic adaption of the font size on cover page.
\newcommand{\ITitleFontSize}
{
  \newlength{\myl}
  \settowidth{\myl}{\IthesisTitle}
  \ifthenelse{\myl>750}{\fontsize{16pt}{14pt}  % Value 750 is experimental
    }{\fontsize{18pt}{20pt}
    }
}
\newcommand{\ICDTitleFontSize}{
  \fontsize{28pt}{25pt}
}

